#pragma once

#include "tools/mathutils.h"
#include <string>

class Music
{
public:
    virtual ~Music() = default;

    virtual bool openFromFile(const std::string& filepath) = 0;

    virtual void play() = 0;
    virtual void pause() = 0;
    virtual void stop() = 0;

    virtual void setVolume(int volume) = 0;

    virtual void setOffset(const microsec& offset) = 0;
    virtual microsec fetchOffset() = 0;
};
