#ifndef CLASSICMAPCREATOR_H
#define CLASSICMAPCREATOR_H

#include <vector>

#include "tools/mathutils.h"
#include "classicgraphicsmanager.h"

struct Beatmap
{
    std::vector<ClassicNote*> notes;
    microsec visibility_offset;
};

class ClassicMapCreator
{
public:
    explicit ClassicMapCreator(const std::shared_ptr<ClassicGraphicsManager>& manager);

     Beatmap createBeatmap(const std::string& filepath) const;

private:
    const std::shared_ptr<ClassicGraphicsManager> _graphics_manager;
};

#endif // CLASSICMAPCREATOR_H
